/** @file config.h
 *  @brief This header file contains data structures and function declarations of config
 *
 *  Copyright (C) 2001-2008, Iwncomm Ltd.
 */
 
#ifndef __CONFIG_H__
#define  __CONFIG_H__

/** Separator equal */
#define SEP_EQUAL '='
/** Separator space */
#define SEP_SPACE ' '
/** Separator tab */
#define SEP_TAB (char)0x9
/** Enable flag */
#define ENABLE 		1
/** Disable flag */
#define DISABLE 		2
/** Verify */
#define MYVERIFY 		3
/** Length */
#define LENGTH		255
/** Keys max */
#define KEYS_MAX 	255

/** Structure: prop_data_st */
struct prop_data_st
{
  /** Key */
  char *key;
  /** Value */
  char *value;
};

/** Typedef: prop_data */
typedef struct prop_data_st prop_data;

/** Structure: asue_config */
struct asue_config
{
	/** Certificate name */
	char cert_name[256];
	/** Used certificate */
	unsigned short used_cert;
	/** Pad */
	unsigned short pad;
};

/** Structure: asue_cert_info */
struct asue_cert_info {
	/** asue config */
	struct asue_config config;
};

int load_prop (char type, char *file_name, prop_data properties[]);
char *get_prop (char *key, char *result, prop_data properties[], int count);
int save_global_conf(char type, char* filename, char *command, char *key, char *value);
int free_prop (prop_data properties[], int count);
int hex2int(char c);
void *get_buffer(int len);
void *free_buffer(void *buffer, int len);
int str2byte( unsigned char *str, int len,  char *byte_out);
int  wpa_network_read(const char *config_file,char *buf, size_t buflen);

#endif
