/** @file ctrl_iface.h
 *  @brief This header file contains data structures and function declarations of ctrl_iface
 *
 *  Copyright (c) 2004-2005, Jouni Malinen <jkmaline@cc.hut.fi>
 *  Copyright (C) 2001-2008, Iwncomm Ltd.
 */

#ifndef CTRL_IFACE_H
#define CTRL_IFACE_H

/** Structure: ctrl_info_st */
struct ctrl_info_st{
	/** version */
	u16 version;
	/** command */
	u16 cmd;
	/** reserved */
	u16 reserved;
	/** length of data */
	u16 length;
	/** data buffer */
	u8 data[];	
};

/** CTRL:version */
#define CTRL_VERSION	0x0001
/** CTRL: message reload request */
#define CTRL_MSG_RELOAD_REQ	0x01
/** CTRL: message reload response */
#define CTRL_MSG_RELOAD_RES	0x01
/** CTRL: message cert check request */
#define CTRL_MSG_CERT_CHECK_REQ	0x02
/** CTRL: message cert check response */
#define CTRL_MSG_CERT_CHECK_RES	0x02
/** CTRL: message status request */
#define CTRL_MSG_STATUS_REQ	0x03
/** CTRL: message status response */
#define CTRL_MSG_STATUS_RES	0x03
/** CTRL: message scanresult request */
#define CTRL_MSG_SCANRESULT_REQ 0x04
/** CTRL: message scanresult response */
#define CTRL_MSG_SCANRESULT_RES	 0x04

int wpa_supplicant_ctrl_iface_init_CGI(struct wapi_asue_st *wpa_s);
void wpa_supplicant_cgi_ctrl_iface_deinit(struct wapi_asue_st *wpa_s);

#endif /* CTRL_IFACE_H */
