/** @file wapi_sm.c
  * @brief This file contains functions for wapi_sm
 *
 *  Copyright (C) 2001-2008, Iwncomm Ltd.
 */

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <unistd.h>
#include <string.h>
#include <assert.h>
 
#include "include/common.h"
#include "include/wapi_asue.h"
#include "include/wapi_asue_i.h"

/** 
 *  @brief       Enable/Disable authorized  
 *
 *  @param wpa_s	  A pointer to a wapi_asue_st structure
 *  @param authorized Enable/Disable authorized flag
 *  @return           None
 */
void wai_set_authorized(struct wapi_asue_st *wpa_s,  int authorized)
{

	if (authorized) {
		wpa_s->wapi_state = WAPI_COMPLETED ;
	} else {
		wpa_s->wapi_state = WAPI_DISCONNECTED;
	}
	wpa_drv_set_authorized(wpa_s, wpa_s->bssid, authorized);
}
